import 'package:equatable/equatable.dart';
import 'package:flutter/material.dart';
import 'package:hydrated_bloc/hydrated_bloc.dart';

import 'package:scrobbles/models/new_artists.dart';

part 'data_new_artists_state.dart';

class DataNewArtistsCubit extends HydratedCubit<DataNewArtistsState> {
  DataNewArtistsCubit() : super(const DataNewArtistsState());

  void getData(DataNewArtistsState state) {
    emit(state);
  }

  NewArtistsData? getValue() {
    return state.newArtists;
  }

  void update(NewArtistsData? newArtists) {
    if ((newArtists != null) && (state.newArtists.toString() != newArtists.toString())) {
      setValue(newArtists);
    }
  }

  void setValue(NewArtistsData? newArtists) {
    emit(DataNewArtistsState(
      newArtists: newArtists,
    ));
  }

  @override
  DataNewArtistsState? fromJson(Map<String, dynamic> json) {
    return DataNewArtistsState(
      newArtists: NewArtistsData.fromJson(json['newArtists']),
    );
  }

  @override
  Map<String, Object?>? toJson(DataNewArtistsState state) {
    return <String, Object?>{
      'newArtists': state.newArtists?.toJson(),
    };
  }
}
